#ifndef CoCoA_DenseMatrix_H
#define CoCoA_DenseMatrix_H

//   Copyright (c)  2005  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.


#include <cstddef>
//using std::size_t;
#include <vector>
//using std::vector;


namespace CoCoA
{

  class ConstMatrix;  // forward declaration -- defined in matrix.H
  class matrix;       // forward declaration -- defined in matrix.H
  class ring;         // forward declaration -- defined in ring.H

  /*-----------------------------------------------------------------*/
  /** \include DenseMatrix.txt  */
  /*-----------------------------------------------------------------*/

  matrix NewDenseMatrix(const ring& R, std::size_t NumRows, std::size_t NumCols);
  matrix NewDenseMatrix(const ring& R, std::size_t NumRows, std::size_t NumCols, const std::vector< std::vector<int> >& M);
  matrix NewDenseMatrix(ConstMatrix M);
  void inverse(matrix& lhs, ConstMatrix M);
  void adjoint(matrix& lhs, ConstMatrix M);
//????  RingElem det(const DenseMatrix& M);
  void mul(matrix& lhs, ConstMatrix M1, ConstMatrix M2);

} // end of namespace CoCoA

#endif
