//   Copyright (c)  1997-2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License (version 2)
//   as published by the Free Software Foundation.  A copy of the full
//   licence may be found in the file COPYING in this directory.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoA; if not, write to the Free Software
//   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "DUPFFfactor.h"
#include <stddef.h>
#include <stdlib.h>
#include "DUPFFsqfrd.h"
#include "berlekamp.h"

DUPFFlist DUPFFfactor(const DUPFF f)
{
  DUPFFlist sqfr_cmpts, ans, iter, iter2, cmpt_factors;

  sqfr_cmpts = DUPFFsqfrd(f);
  ans = NULL;

  /* Apply Berlekamp to each component... */
  for (iter=sqfr_cmpts; iter; iter = iter->next)
  {
    cmpt_factors = Berlekamp(iter->poly);
    for (iter2 = cmpt_factors; iter2; iter2 = iter2->next)
      iter2->deg = iter->deg;
    ans = DUPFFlist_append(ans, cmpt_factors);
  }

  DUPFFlist_dtor(sqfr_cmpts);

  return ans;
}
